<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VehicleMonitoringCapabilityRequestPolicyStructure
 * StructType
 * Meta informations extracted from the WSDL
 * - documentation: Type for capability request policy.
 * @subpackage Structs
 */
class VehicleMonitoringCapabilityRequestPolicyStructure extends CapabilityRequestPolicyStructure
{
    /**
     * The HasReferences
     * Meta informations extracted from the WSDL
     * - documentation: Whether results should return references.
     * - minOccurs: 0
     * @var bool
     */
    public $HasReferences;
    /**
     * The HasNames
     * Meta informations extracted from the WSDL
     * - default: false
     * - documentation: Whether results should return references.
     * - minOccurs: 0
     * @var bool
     */
    public $HasNames;
    /**
     * Constructor method for VehicleMonitoringCapabilityRequestPolicyStructure
     * @uses VehicleMonitoringCapabilityRequestPolicyStructure::setHasReferences()
     * @uses VehicleMonitoringCapabilityRequestPolicyStructure::setHasNames()
     * @param bool $hasReferences
     * @param bool $hasNames
     */
    public function __construct($hasReferences = null, $hasNames = false)
    {
        $this
            ->setHasReferences($hasReferences)
            ->setHasNames($hasNames);
    }
    /**
     * Get HasReferences value
     * @return bool|null
     */
    public function getHasReferences()
    {
        return $this->HasReferences;
    }
    /**
     * Set HasReferences value
     * @param bool $hasReferences
     * @return \StructType\VehicleMonitoringCapabilityRequestPolicyStructure
     */
    public function setHasReferences($hasReferences = null)
    {
        // validation for constraint: boolean
        if (!is_null($hasReferences) && !is_bool($hasReferences)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($hasReferences)), __LINE__);
        }
        $this->HasReferences = $hasReferences;
        return $this;
    }
    /**
     * Get HasNames value
     * @return bool|null
     */
    public function getHasNames()
    {
        return $this->HasNames;
    }
    /**
     * Set HasNames value
     * @param bool $hasNames
     * @return \StructType\VehicleMonitoringCapabilityRequestPolicyStructure
     */
    public function setHasNames($hasNames = false)
    {
        // validation for constraint: boolean
        if (!is_null($hasNames) && !is_bool($hasNames)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($hasNames)), __LINE__);
        }
        $this->HasNames = $hasNames;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VehicleMonitoringCapabilityRequestPolicyStructure
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
